Index: lib/matplotlib/colors.py
===================================================================
--- lib/matplotlib/colors.py	(revision 6100)
+++ lib/matplotlib/colors.py	(working copy)
@@ -252,7 +252,23 @@
 
         try:
             if cbook.is_string_like(arg):
-                color = self.colors.get(arg, None)
+                # if arg contains "!", try color mix.  
+                # e.g., "red!30!white" mixes 30% of red with 70% of white.
+                # red!40!blue!30!white means (red!40!blue)!30!white
+                # "!" is searched from the end of the string and
+                # to_rgb method is recursively called
+                ind_last = arg.rfind("!")
+                if ind_last != -1:
+                    ind1 = arg.rfind("!", 0, ind_last)
+                    if ind1 == -1: raise ValueError("incorrect color mix expression : %s"%(arg))
+                    color1 = self.to_rgb(arg[:ind1])
+                    mix = 0.01 * float(arg[ind1+1:ind_last])
+                    color2 = self.to_rgb(arg[ind_last+1:])
+                    color = tuple([c1*mix + c2*(1.-mix) \
+                                   for c1, c2 in zip(color1, color2)])
+                else:
+                    color = self.colors.get(arg, None)
+                    
                 if color is None:
                     str1 = cnames.get(arg, arg)
                     if str1.startswith('#'):
